<?php
//obtain your APIToken from the user section once logged into BinaryCanary.com
$APIToken = "aaaabbbbaaaabbbbaaaabbbbaaaabbbb";

// set your site as the referrer (example: http://yoursite.com)
$referer = "http://myCompany.com";

$xmlstr ="<?xml version='1.0' encoding='UTF-8'?>
<BinaryCanary>
<APIKey>".$APIToken."</APIKey>
<Method>listMonitors</Method>
<Parameters>
  <Monitor>
  </Monitor>
</Parameters>
</BinaryCanary>"; 

$url = "https://binarycanary.com/api/";

$data["BinaryCanary_XML"] = $xmlstr;

list($header, $content) = PostRequest($url,$referer,$data);
// For Debugging, and to see the fields returned: print the result of the whole request:
//print $content;
$xml = new SimpleXMLElement($content);
$items = $xml->xpath('*/Monitor');
$ResponseText = "<table>";
$col = 0;
foreach($items as $item) {
	if ($item->MonitorStatus == 'Active') {
		if($col == 0) {
			$ResponseText .= "<tr>";
		}
		$ResponseText .= "<td style='padding: 3px 10px 0 10px;'>";
		$ResponseText .= "<p style='line-height:.5em;'>";
		if($item->CurrentMonitoringStatus == 'Pass') {
			$ResponseText .= "<font size='3' color='green'>";
		}
		else {
			$ResponseText .=  "<font size='3' color='red'>";
		}
    	$ResponseText .=  $item->MonitorName;
    	$ResponseText .=  "</font></p></td>";
		if($col == 1) {
			$col = 0;
			$ResponseText .= "</tr>";
		}
		else {
			$col = 1;
		}
    }
}
$ResponseText .= "</Table>";
$responseXML ="<?xml version='1.0' encoding='UTF-8'?>
<root>
	<item>
		<text><![CDATA[".$ResponseText."]]></text>
		<type>0</type>
	</item>
</root>";
echo $responseXML;


function PostRequest($url, $referer, $_data) {
    // convert variables array to string:
    $data = array();    
    while(list($n,$v) = each($_data)){
		$n = urlencode($n);
		$v = urlencode($v);
        $data[] = "$n=$v";
    }    
    $data = implode('&', $data);
    // format --> test1=a&test2=b etc.
 
    // parse the given URL
    $url = parse_url($url);
    if ($url['scheme'] != 'https') { 
        die('Only HTTP request are supported !');
    }
 
    // extract host and path:
    $host = $url['host'];
    $path = $url['path'];
 
    // open a socket connection on port 80
    $fp = fsockopen($host, 80);
 
    // send the request headers:
    fputs($fp, "POST $path HTTP/1.1\r\n");
    fputs($fp, "Host: $host\r\n");
    fputs($fp, "Referer: $referer\r\n");
    fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
    fputs($fp, "Content-length: ". strlen($data) ."\r\n");
    fputs($fp, "Connection: close\r\n\r\n");
    fputs($fp, $data);
 
    $result = ''; 
    while(!feof($fp)) {
        // receive the results of the request
        $result .= fgets($fp, 128);
    }
 
    // close the socket connection:
    fclose($fp);
 
    // split the result header from the content
    $result = explode("\r\n\r\n", $result, 2);
 
    $header = isset($result[0]) ? $result[0] : '';
    $content = isset($result[1]) ? $result[1] : '';
 
    // return as array:
    return array($header, $content);
}

?>